From f5f3f79e73403a12ebc98b6ee0ae34bed518ead5 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Wed, 19 May 2021 14:56:00 +0200
Subject: [PATCH] fonts: add Krub (#54121)

---
 README                                        |   7 ++++++
 static/fonts/Krub/Krub-Bold.woff              | Bin 0 -> 59764 bytes
 static/fonts/Krub/Krub-Bold.woff2             | Bin 0 -> 48928 bytes
 static/fonts/Krub/Krub-BoldItalic.woff        | Bin 0 -> 63156 bytes
 static/fonts/Krub/Krub-BoldItalic.woff2       | Bin 0 -> 51792 bytes
 static/fonts/Krub/Krub-ExtraLight.woff        | Bin 0 -> 59024 bytes
 static/fonts/Krub/Krub-ExtraLight.woff2       | Bin 0 -> 48364 bytes
 static/fonts/Krub/Krub-ExtraLightItalic.woff  | Bin 0 -> 61400 bytes
 static/fonts/Krub/Krub-ExtraLightItalic.woff2 | Bin 0 -> 50128 bytes
 static/fonts/Krub/Krub-Italic.woff2           | Bin 0 -> 50916 bytes
 static/fonts/Krub/Krub-Light.woff             | Bin 0 -> 59556 bytes
 static/fonts/Krub/Krub-Light.woff2            | Bin 0 -> 48808 bytes
 static/fonts/Krub/Krub-LightItalic.woff       | Bin 0 -> 61868 bytes
 static/fonts/Krub/Krub-LightItalic.woff2      | Bin 0 -> 50636 bytes
 static/fonts/Krub/Krub-Medium.woff            | Bin 0 -> 60376 bytes
 static/fonts/Krub/Krub-Medium.woff2           | Bin 0 -> 49556 bytes
 static/fonts/Krub/Krub-MediumItalic.woff      | Bin 0 -> 63264 bytes
 static/fonts/Krub/Krub-MediumItalic.woff2     | Bin 0 -> 51764 bytes
 static/fonts/Krub/Krub-Regular.woff           | Bin 0 -> 59556 bytes
 static/fonts/Krub/Krub-Regular.woff2          | Bin 0 -> 48800 bytes
 static/fonts/Krub/Krub-RegularItalic.woff     | Bin 0 -> 62256 bytes
 static/fonts/Krub/Krub-SemiBold.woff          | Bin 0 -> 60648 bytes
 static/fonts/Krub/Krub-SemiBold.woff2         | Bin 0 -> 49884 bytes
 static/fonts/Krub/Krub-SemiBoldItalic.woff    | Bin 0 -> 63412 bytes
 static/fonts/Krub/Krub-SemiBoldItalic.woff2   | Bin 0 -> 51996 bytes
 static/includes/fonts/_krub.scss              |  23 ++++++++++++++++++
 26 files changed, 30 insertions(+)
 create mode 100644 static/fonts/Krub/Krub-Bold.woff
 create mode 100644 static/fonts/Krub/Krub-Bold.woff2
 create mode 100644 static/fonts/Krub/Krub-BoldItalic.woff
 create mode 100644 static/fonts/Krub/Krub-BoldItalic.woff2
 create mode 100644 static/fonts/Krub/Krub-ExtraLight.woff
 create mode 100644 static/fonts/Krub/Krub-ExtraLight.woff2
 create mode 100644 static/fonts/Krub/Krub-ExtraLightItalic.woff
 create mode 100644 static/fonts/Krub/Krub-ExtraLightItalic.woff2
 create mode 100644 static/fonts/Krub/Krub-Italic.woff2
 create mode 100644 static/fonts/Krub/Krub-Light.woff
 create mode 100644 static/fonts/Krub/Krub-Light.woff2
 create mode 100644 static/fonts/Krub/Krub-LightItalic.woff
 create mode 100644 static/fonts/Krub/Krub-LightItalic.woff2
 create mode 100644 static/fonts/Krub/Krub-Medium.woff
 create mode 100644 static/fonts/Krub/Krub-Medium.woff2
 create mode 100644 static/fonts/Krub/Krub-MediumItalic.woff
 create mode 100644 static/fonts/Krub/Krub-MediumItalic.woff2
 create mode 100644 static/fonts/Krub/Krub-Regular.woff
 create mode 100644 static/fonts/Krub/Krub-Regular.woff2
 create mode 100644 static/fonts/Krub/Krub-RegularItalic.woff
 create mode 100644 static/fonts/Krub/Krub-SemiBold.woff
 create mode 100644 static/fonts/Krub/Krub-SemiBold.woff2
 create mode 100644 static/fonts/Krub/Krub-SemiBoldItalic.woff
 create mode 100644 static/fonts/Krub/Krub-SemiBoldItalic.woff2
 create mode 100644 static/includes/fonts/_krub.scss

diff --git a/README b/README
index 83795d05..971f3b1f 100644
--- a/README
+++ b/README
@@ -309,12 +309,19 @@ copyright notices:
   #
   # https://github.com/impallari/DancingScript
 
 * Baloo 2
   # Baloo 2 is Copyright (c) 2019 Ek Type (www.ektype.in)
   # Licensed under the SIL Open Font License 1.1 (http://scripts.sil.org/OFL).
   #
   # https://github.com/EkType/Baloo2
+
+* Krub
+  # Copyright 2018 The Krub Project Authors (https://github.com/cadsondemak/Krub)
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://github.com/cadsondemak/Krub/
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
 static/$theme/README for details.
diff --git a/static/fonts/Krub/Krub-Bold.woff b/static/fonts/Krub/Krub-Bold.woff
new file mode 100644
index 0000000000000000000000000000000000000000..8c03d718e189cb0af0bc616c3ab67b790b62c2f8
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Bold.woff2 b/static/fonts/Krub/Krub-Bold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3c0afbb6c3f01863f11f86492922813ba65e5739
GIT binary patch
diff --git a/static/fonts/Krub/Krub-BoldItalic.woff b/static/fonts/Krub/Krub-BoldItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..a86a6e20c46f61b36e627a21036c175947cae885
GIT binary patch
diff --git a/static/fonts/Krub/Krub-BoldItalic.woff2 b/static/fonts/Krub/Krub-BoldItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..506dafa0144f246151f7e087f7c71da9c279553f
GIT binary patch
diff --git a/static/fonts/Krub/Krub-ExtraLight.woff b/static/fonts/Krub/Krub-ExtraLight.woff
new file mode 100644
index 0000000000000000000000000000000000000000..eb2faeff0c35e7dfed90b882f63e7539a9c971f9
GIT binary patch
diff --git a/static/fonts/Krub/Krub-ExtraLight.woff2 b/static/fonts/Krub/Krub-ExtraLight.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..40345ce1937843c283ceae5c3a06fddda6682d48
GIT binary patch
diff --git a/static/fonts/Krub/Krub-ExtraLightItalic.woff b/static/fonts/Krub/Krub-ExtraLightItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..01575cef5005885f5d35edc1ec28e00183692565
GIT binary patch
diff --git a/static/fonts/Krub/Krub-ExtraLightItalic.woff2 b/static/fonts/Krub/Krub-ExtraLightItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..754c4fce0a6a3e6b560b920f714ec26ddb9767cc
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Italic.woff2 b/static/fonts/Krub/Krub-Italic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..e8a33f129cac1ab919b63e13bef9944f75736729
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Light.woff b/static/fonts/Krub/Krub-Light.woff
new file mode 100644
index 0000000000000000000000000000000000000000..5729f34de973cff086689c20bbfab97ce7844374
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Light.woff2 b/static/fonts/Krub/Krub-Light.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..92c43a03557462a06896e9dc4f1e91c48b1ef318
GIT binary patch
diff --git a/static/fonts/Krub/Krub-LightItalic.woff b/static/fonts/Krub/Krub-LightItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..517631eaf3c99043924903f7b07b107bbb1af6dd
GIT binary patch
diff --git a/static/fonts/Krub/Krub-LightItalic.woff2 b/static/fonts/Krub/Krub-LightItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..de962c62c8a267b0d2dc06aea5be73f71800d152
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Medium.woff b/static/fonts/Krub/Krub-Medium.woff
new file mode 100644
index 0000000000000000000000000000000000000000..9075417094bf1a10d502de25920a1a8a880ae0fc
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Medium.woff2 b/static/fonts/Krub/Krub-Medium.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..4d45925de0fa2bab10171470f9ac1073972dc0c9
GIT binary patch
diff --git a/static/fonts/Krub/Krub-MediumItalic.woff b/static/fonts/Krub/Krub-MediumItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..424a8130f6d8cfa4cd48ef9e3a71f0f3e55c3322
GIT binary patch
diff --git a/static/fonts/Krub/Krub-MediumItalic.woff2 b/static/fonts/Krub/Krub-MediumItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..7425ab5f037bd1d5a3a82c5f84baa8c4ab745674
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Regular.woff b/static/fonts/Krub/Krub-Regular.woff
new file mode 100644
index 0000000000000000000000000000000000000000..8f15cf97452b18fbe805f0ea14d5bddde131adff
GIT binary patch
diff --git a/static/fonts/Krub/Krub-Regular.woff2 b/static/fonts/Krub/Krub-Regular.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..81a9da11bb3f6dc9383b1de2e02acb1b95859b0d
GIT binary patch
diff --git a/static/fonts/Krub/Krub-RegularItalic.woff b/static/fonts/Krub/Krub-RegularItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..d8185c0744edb01ab119ced53faefe03043320f3
GIT binary patch
diff --git a/static/fonts/Krub/Krub-SemiBold.woff b/static/fonts/Krub/Krub-SemiBold.woff
new file mode 100644
index 0000000000000000000000000000000000000000..96d07a2d87945950e7cec634556908ec5e55d15c
GIT binary patch
diff --git a/static/fonts/Krub/Krub-SemiBold.woff2 b/static/fonts/Krub/Krub-SemiBold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..857d1c70d4e14e16ff8df48005d37862c0392573
GIT binary patch
diff --git a/static/fonts/Krub/Krub-SemiBoldItalic.woff b/static/fonts/Krub/Krub-SemiBoldItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..8ddc80cb41e3bf42e111bfcb4b88db4ad40cde5b
GIT binary patch
diff --git a/static/fonts/Krub/Krub-SemiBoldItalic.woff2 b/static/fonts/Krub/Krub-SemiBoldItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..4ba5d833c745b93cf3599bb79894a749889a91ac
GIT binary patch
diff --git a/static/includes/fonts/_krub.scss b/static/includes/fonts/_krub.scss
new file mode 100644
index 00000000..113f726a
--- /dev/null
+++ b/static/includes/fonts/_krub.scss
@@ -0,0 +1,23 @@
+@mixin krub-font($type, $weight) {
+	@font-face {
+		font-family: 'Krub';
+		src: url('/static/fonts/Krub/Krub-#{$type}.woff2') format('woff2'),
+		     url('/static/fonts/Krub/Krub-#{$type}.woff') format('woff');
+		font-weight: $weight;
+		font-style: normal;
+	}
+	@font-face {
+		font-family: 'Krub';
+		src: url('/static/fonts/Krub/Krub-#{$type}Italic.woff2') format('woff2'),
+		     url('/static/fonts/Krub/Krub-#{$type}Italic.woff') format('woff');
+		font-weight: $weight;
+		font-style: italic;
+	}
+}
+
+@include krub-font('Extralight', 200);
+@include krub-font('Light', 300);
+@include krub-font('Regular', 400);
+@include krub-font('Medium', 500);
+@include krub-font('Semibold', 600);
+@include krub-font('Bold', 700);
-- 
2.30.2