From e7a5ae7a6cbfefac655a377e9a23f0970baf6ee2 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Thu, 20 May 2021 18:45:12 +0200
Subject: [PATCH] eurelien-cd28: add theme (#54143)

---
 static/eurelien-cd28/_custom.scss    |  83 +++++++++++++++++++++++++++
 static/eurelien-cd28/_vars.scss      |  33 +++++++++++
 static/eurelien-cd28/config.json     |  15 +++++
 static/eurelien-cd28/img/favicon.ico | Bin 0 -> 105382 bytes
 static/eurelien-cd28/style.scss      |   5 ++
 5 files changed, 136 insertions(+)
 create mode 100644 static/eurelien-cd28/_custom.scss
 create mode 100644 static/eurelien-cd28/_vars.scss
 create mode 100644 static/eurelien-cd28/config.json
 create mode 100644 static/eurelien-cd28/img/favicon.ico
 create mode 100644 static/eurelien-cd28/style.scss

diff --git a/static/eurelien-cd28/_custom.scss b/static/eurelien-cd28/_custom.scss
new file mode 100644
index 00000000..f77994ad
--- /dev/null
+++ b/static/eurelien-cd28/_custom.scss
@@ -0,0 +1,83 @@
+@import '../includes/fonts/titillium';
+@import '../includes/fonts/krub';
+
+#header #top #logo {
+	@media screen and ($min-desktop-viewport) {
+		a {
+			margin-top: 50px;
+			line-height: 80px;
+			font-size: 16px;
+			font-family: $title-font-family;
+			color: black;
+			text-indent: 500px;
+			text-decoration: none;
+		}
+	}
+	@media screen and ($max-mobile-viewport) {
+		padding-top: 30px;
+		a {
+			display: block;
+			height: 60px;
+		}
+	}
+}
+
+div.gru-nav-wrapper {
+	margin: auto;
+	max-width: 1316px;
+	margin-top: 25px;
+	margin-bottom: 45px;
+	background-color: $secondary-color;
+	div.gru-nav {
+		background-color: $secondary-color;
+		ul {
+			> li {
+				border-left: 2px solid white;
+				border-right: 2px solid white;
+				&.selected {
+					background-color: $primary-color;
+				}
+				&:not(.selected) {
+					background-color: $nav-background;
+				}
+				> a {
+					font-size: 19px;
+					font-weight: 400;
+					line-height: 36px;
+					padding: 0 15px;
+				}
+			}
+		}
+	}
+}
+
+div.gru-nav .gru-nav-button {
+	background-color: $secondary-color;
+	.icon-bar {
+		border: 2px solid $nav-button-color;
+	}
+}
+
+.gru-content div.cell h2:first-child {
+	font-size: 30px;
+	margin: 0px;
+}
+
+input, input[type="search"], textarea, select, div.file-upload-widget div.file-button {
+	box-shadow: inset 1px 2px 3px 0 #c5c5c5;
+}
+
+.required {
+	color: #c00;
+}
+
+div.buttons {
+	font-size: $title-font-size;
+	.cancel-button button, .previous-button button{
+		background: $nav-background;
+	}
+}
+
+.pk-information {
+	@include notification-message($notification_info_color, "\f164");
+}
diff --git a/static/eurelien-cd28/_vars.scss b/static/eurelien-cd28/_vars.scss
new file mode 100644
index 00000000..a80a70d3
--- /dev/null
+++ b/static/eurelien-cd28/_vars.scss
@@ -0,0 +1,33 @@
+$primary-color: #ffcd00;
+$secondary-color: #e5e5e5;
+
+$width: 946px;
+$sidebar-position: right;
+$link-color: #087C81;
+
+$font-size: 1em;
+$font-family: Krub;
+$font-color: #313131;
+
+$title-color: #777;
+$title-font-size: 19px;
+$title-font-family: "Titillium";
+
+$nav-background: #b7b7b7;
+$nav-color: #363636;
+$nav-submenu-color: $nav-color;
+$nav-active-color: $primary-color;
+$nav-item-selected-color: $nav-color;
+$nav-border-color: transprent;
+$nav-menu-side: 40px;
+$nav-mobile-mode: hamburger;
+
+$cell-border: 1px dotted $secondary-color;
+
+$widget-background: #f3f3f3;
+
+$button-background: $primary-color;
+$button-color: $nav-color;
+
+$footer-background: $secondary-color;
+$footer-color: $font-color;
diff --git a/static/eurelien-cd28/config.json b/static/eurelien-cd28/config.json
new file mode 100644
index 00000000..00cc74c2
--- /dev/null
+++ b/static/eurelien-cd28/config.json
@@ -0,0 +1,15 @@
+{
+  "label": "Eurelien (CD28)",
+  "variables": {
+    "theme_color": "#ffcd00",
+    "favicon": "eurelien-cd28/img/favicon.ico"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:background": { "label": "Têtière : fond" },
+        "header:logo": { "label": "Têtière : logo" }
+      }
+    }
+  }
+}
diff --git a/static/eurelien-cd28/img/favicon.ico b/static/eurelien-cd28/img/favicon.ico
new file mode 100644
index 0000000000000000000000000000000000000000..f1c110fc58c93dafefefe6e6dde87a186edce16b
GIT binary patch
diff --git a/static/eurelien-cd28/style.scss b/static/eurelien-cd28/style.scss
new file mode 100644
index 00000000..1fd447de
--- /dev/null
+++ b/static/eurelien-cd28/style.scss
@@ -0,0 +1,5 @@
+@charset "UTF-8";
+
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.30.2